function DumpObj(obj) {
    var dump = "";
    dump += obj;
    for (objKey in obj)
        dump += "\n" + objKey.toString() + " : <" + obj[objKey] + ">";
    if (!dump)
        dump = "DumpObj empty";
    return dump;
}

var MsgBox = new ActiveXObject("Wscript.shell");

var ArrNodeSelect = []; //  
var ArrNodeSort = []; //  
var ArrElem = []; //  
var baseNode1; //  
var baseNode2; //  
var okrugLen = 3; //   ,   


function Plugin_ActivateUI(engine) {
    engine.Execute();
}

function Plugin_Execute(engine) {
    try {
        var model = engine.GetModel();
        var editor = engine.GetEditor();
        var view = engine.GetView();

        SelectNode();
        if (ArrNodeSelect.length > 0) {
            ArrNodeSort = SortNode();
            CreatElemInModel();
            RigidAddOrUpdate();
            AddGroupElem();
            setBound();
        }
        else
            MsgBox.Popup('   !!');

    }
    catch (e) {
        engine.Cancel(DumpObj(e));
    }

    function Node(num, x, y, z) {
        this.num = num;
        this.x = x;
        this.y = y;
        this.z = z;
    }

     //      
    function SelectNode() {
        var prop = { ListNode: [] }
        view.GetSelection(prop);
        if (prop.ListNode != null) {
            ArrNodeSelect = prop.ListNode.toArray();
            //MsgBox.Popup(model.GetBound(ArrNodeSelect[0]));
        }
    }

    function ValMidle(nodes, a) {
        var Sum = 0;
        for (var i = 0; i < nodes.length; i++)
            Sum += NodeXYZval(nodes[i], a);
        return Sum / nodes.length;
    }

    function NodeXYZval(numNode, XYZ) { ///XYZ - 1 2 3
        var NodeProp = { x: 0, y: 0, z: 0 };
        model.GetNode(numNode, NodeProp);
        var val;
        switch (XYZ) {
            case 1: val = NodeProp.x; break;
            case 2: val = NodeProp.y; break;
            case 3: val = NodeProp.z; break;
            default: break;
        }
        return val;
    }


    function CreatNodeInModel(node) {
        node.num = editor.NodeAdd(1);
        editor.NodeUpdate(
            node.num,
            {
                x: node.x,
                y: node.y,
                z: node.z
            }
       )
    }

    function CreatElemInModel() {
        CreatNodeInModel(baseNode1);
        if (ArrNodeSort.length > 1)
            CreatNodeInModel(baseNode2);
        var listnode = [];
        listnode.push(baseNode1.num);
        listnode.push(ArrNodeSort.length > 1 ? baseNode2.num : ArrNodeSelect[0]);
        CreatElem(listnode);

        if (ArrNodeSort.length > 1)
            for (var i = 0; i < ArrNodeSort.length; i++) {
                var list = [];
                list.push(ArrNodeSort[i].num);
                list.push(baseNode2.num);
                CreatElem(list);
            }

        if (ArrNodeSort.length > 2)
            for (var i = 0; i < ArrNodeSort.length; i++) { 
                var j = (i < (ArrNodeSort.length - 1) ? j = i + 1 : j = 0);
                var list = [];
                list.push(ArrNodeSort[i].num);
                list.push(ArrNodeSort[j].num);
                CreatElem(list);
            }

    }
   function CreatElem(listnode) {
       var numEl = editor.ElemAdd(1);
       ArrElem.push(numEl);
        editor.ElemUpdate(
            numEl,
            {
                Text: "AutoCross",
                ListNode: listnode,
                NumSysCoord: 0,
                TypeElem: 5
            }
        )
    }

    function NodeXYZ(numNode) {
        var NodeProp = { x: 0, y: 0, z: 0 };
        model.GetNode(numNode, NodeProp);
        return new Node(numNode, NodeProp.x, NodeProp.y, NodeProp.z);
    }

    function SortNode() {
        var nodes = ArrNodeSelect;

        var baseNode = new Node(0, ValMidle(ArrNodeSelect, 1), ValMidle(ArrNodeSelect, 2), ValMidle(ArrNodeSelect, 3));
        baseNode2 = new Node(0, baseNode.x, baseNode.y, baseNode.z);
        baseNode1 = new Node(0, baseNode2.x, baseNode2.y, baseNode2.z - 0.1);

        var ListNideObj = [];
        for (var n = 0; n < nodes.length; n++)
            ListNideObj.push(new NodeXYZ(nodes[n]));
        var listNodeGr = [];
        var listGr = [];
        var n = ListNideObj.length;
        for (var i = 0; i < n; i++) {
            var _in = ListNideObj[i];
            var ax = _in.x - baseNode.x;
            var by = _in.y - baseNode.y;
            var r = alfa(ax, by);
            listGr.push(r);
            listNodeGr.push(new Noderad(_in, r));
        }
       
        var listGrSort = listGr.sort(compareNumbers);
        var ArrNodeNew = [];
        for (var ri = 0; ri < listGrSort.length; ri++) {
            var _r = listGrSort[ri];
            for (var ni = 0; ni < listNodeGr.length; ni++) {
                if (_r == listNodeGr[ni].grad) {
                    ArrNodeNew.push(listNodeGr[ni].node);
                    break;
                }
            }
        }
        function compareNumbers(a, b) {
            return a - b;
        }
        function Noderad(node, grad) {
            this.node = node;
            this.grad = grad;
        }
        function alfa(cosX, sinY) {
            var tg = sinY / cosX;
            var r = Math.atan(Math.abs(tg)) * 180 / Math.PI;
            if (cosX > 0 && sinY > 0 && tg > 0) r = 0 + r; // 1
            if (cosX < 0 && sinY > 0 && tg < 0) r = 180 - r; // 2
            if (cosX < 0 && sinY < 0 && tg > 0) r = 180 + r; // 3
            if (cosX > 0 && sinY < 0 && tg < 0) r = 0 - r; // 4
            if (cosX > 0 && sinY == 0) r = 0; // 1
            if (cosX < 0 && sinY == 0) r = 180; // 2
            if (cosX == 0 && sinY > 0) r = 90; // 3
            if (cosX == 0 && sinY < 0) r = 270; // 4
            return Math.round(r);
        }

        return ArrNodeNew;
    }

    function RigidAddOrUpdate() {
        var textR = 'AutoCross';
        var Descr = "S0 3.31e+015 1 1 NU 0.2 RO 1.00000e-008 TMP 1e-005 Shift 4.8652e+007 1.85155e+009 1.85155e+009 DAMPER 0.00875285";

        var rigN = 0;
        var rigBool = false;
        var rigQuantity = model.GetQuantityRigid();
        for (var r = 1; r <= rigQuantity; r++) {
            var PropRig = { Text: '' }
            model.GetRigid(r, PropRig); //     
            if (PropRig.Text == textR) {
                rigN = r;
                rigBool = true;
                break;
            }
        }
        if (rigBool) {
            var listEl = [];
            var PropRig = { ListElem: [] }
            model.GetRigid(rigN, PropRig); //     
            listEl = PropRig.ListElem.toArray();
            for (var i = 0; i < ArrElem.length; i++) 
                listEl.push(ArrElem[i]);

            editor.RigidUpdate(rigN, { ListElem: listEl});
        }
        else
            editor.RigidAdd({ Text: textR, ListElem: ArrElem, Description: Descr });
    }

    function AddGroupElem() {
        editor.GroupElemUpdate(editor.GroupElemAdd(), { Text: '_-cross_3', ListElem: ArrElem[0] });
    }
    function setBound() {
        editor.SetBound({ Mask: 0, ListNode: ArrNodeSelect }, true);
        var ListNode = [];
        ListNode.push(baseNode1.num);
        editor.SetBound({ Mask: 63, ListNode: ListNode }, true); //baseNode1.num

    }

}

